;ClipStep.ahk
; MOD: Ctrl-Alt-V added to Toggle Current (%A_WorkingDir%) & Permanent dir: .\Perm
;	This option only available after ^V pressed
; MOD: SHOWCLIP (^V) uses Progress for readability and shows Previous & Next clip
; Control multiple clipboards using only the keyboard's Ctrl-X-C-V
;
; Select some text, press Ctrl-C a couple of times to copy it to multiple new clipboards. 
; Now hold down Ctrl and press V repeatedly to step through the clipboards. C steps backwards. 
; When you've got the clipboard you want, release Ctrl to paste. 
; To delete a clipboard, hold down Ctrl, press V followed by X twice to delete, three times to 
; delete all, or once to cancel. Release Ctrl to accept. 
;
; The clipboards are saved to separate files, so place the sctipt in it's own folder. 
;
;Skrommel @2005

SetBatchLines,-1

perm_cur=
numofclips=0
activeclip=1
paste=no
delete=no

Gosub,INDEX

LOOP:
Sleep,100
GetKeyState,state,CTRL
If state=u
{
  If delete=delete
  { 
    readclip=filearray%activeclip%
    readclip:=%readclip%
    Filedelete,%perm_cur%%readclip%.clip
    tooltip=Deleting Clip %perm_cur%%activeclip% of %numofclips%
    Gosub,TOOLTIP
    Gosub,INDEX
    Gosub,FINDPREV
  }
  Else
  If delete=all
  {
    tooltip=Deleting all %perm_cur%clips
    Gosub,TOOLTIP
    Filedelete,%perm_cur%*.clip
    numofclips=0
    activeclip=0
    filearray1=0
    Gosub,INDEX
    activeclip=%numofclips%
  }
  Else    
  If paste=paste
  {
    readclip=filearray%activeclip%
    readclip:=%readclip%
    tooltip=Pasting clip %perm_cur% %activeclip%
    Gosub,TOOLTIP
    Gosub,PASTECLIP
  }
  delete=no
  paste=no
}
Goto,LOOP


$^x::
; SplashTextOff
; showflag true indicates ^v (SHOWCLIP) mode, & enables key ^!v 
showflag = %Null_var%

Progress, Off
If paste<>no
{
  If delete=delete
  {
;    ToolTip,Delete all clips
;    SetTimer,TOOLTIPOFF,Off
    tooltip=Delete all clips
    Gosub,TOOLTIP
    delete=all
    paste=yes
    Return
  }
  Else
  If delete=cancel
  {
    If numofclips<1
    {
      tooltip=%perm_cur% - No clip exists
      Gosub,TOOLTIP
      Return
    }
    readclip=filearray%activeclip%
    readclip:=%readclip%
    FileRead,Clipboard,*c %perm_cur%%readclip%.clip
    StringLeft,clip,Clipboard,100
;    ToolTip,Delete Clip %perm_cur%%activeclip% of %numofclips%`n%clip%
;    SetTimer,TOOLTIPOFF,Off
    tooltip=Delete Clip %perm_cur%%activeclip% of %numofclips%`n%clip%
    Gosub,TOOLTIP
    delete=delete
    paste=yes
    Return
  }
  Else
  {
    tooltip=Cancel
    Gosub,TOOLTIP
    delete=cancel
    paste=yes
    Return
  }
}
clip1:=ClipboardAll
Clipboard=
Send,^x
ClipWait,1
clip2:=ClipboardAll
If clip2=
{
  tooltip=Empty selection %perm_cur%
  Gosub,TOOLTIP
}
Else
If clip1<>%clip2%
{
  tooltip=Copying to clip 1 %perm_cur%
  Gosub,TOOLTIP
  Gosub,ADDCLIP
  Gosub,INDEX
}
Else
{
  tooltip=%perm_cur% - Same selection
  Gosub,TOOLTIP
}
clip1=
clip2=
Return

 
$^c::
; SplashTextOff 
; showflag true indicates ^v (SHOWCLIP) mode, & enables key ^!v 
showflag = %Null_var%
Progress, Off
If paste<>no
{
  If numofclips<1
  {
    tooltip=%perm_cur% - No clip exists
    Gosub,TOOLTIP
    delete=no
    paste=yes
    Return
  }
  Gosub,FINDPREV
  Gosub,SHOWCLIP
  delete=no
  paste=paste
  Return
}
clip1:=ClipboardAll
Clipboard=
Send,^c
clip2:=ClipboardAll
If clip2=
{
  tooltip=Empty selection
  Gosub,TOOLTIP
}
Else
If clip1<>%clip2%
{
  tooltip=Copying to clip 1 %perm_cur%
  Gosub,TOOLTIP
  Gosub,ADDCLIP
  Gosub,INDEX
}
Else
{
  tooltip=%perm_cur% - Same selection
  Gosub,TOOLTIP
}
clip1=
clip2=
Return

$^v::

curperm_Ret:
; SplashTextOff 
Progress, Off
If numofclips<1
{
  tooltip=%perm_cur% - No clip exists
  showflag = 1
  Gosub,TOOLTIP
  delete=no
  paste=yes
  Return
}
If paste<>no
  Gosub,FINDNEXT
Gosub,SHOWCLIP
delete=no
paste=paste
Return

; #IfWinExist, Clip
$^!v::
; SplashTextOff 
; showflag true indicates ^v (SHOWCLIP) mode, & enables key ^!v 
If Showflag
  Goto, Permswitch
Send, ^!v
Return

Permswitch:
Progress, Off
showflag = %Null_var%
If perm_cur = Perm\
  Goto, clear_perm

perm_cur = Perm\
IfNotExist, Perm
  FileCreateDir, Perm
tooltip=Switching to Permanent
Gosub,TOOLTIP
numofclips=0
activeclip=1
Gosub,INDEX
Goto, curperm_Ret

clear_perm:
perm_cur = %Null_var%
tooltip=Switching to Current
Gosub,TOOLTIP
numofclips=0
activeclip=1
Gosub,INDEX
Goto, curperm_Ret
;  Return


ADDCLIP:
readclip=filearray1
readclip:=%readclip%
lastclip=%readclip%
lastclip+=1
numofclips+=1
activeclip=1
IfExist,%perm_cur%%lastclip%.clip
  FileDelete,%perm_cur%%lastclip%.clip
FileAppend,%ClipboardAll%,%perm_cur%%lastclip%.clip
Return


SHOWCLIPsr:
readclip=filearray%activeclip%
readclip:=%readclip%
IfExist,%perm_cur%%readclip%.clip
  FileRead,Clipboard,*c %perm_cur%%readclip%.clip
StringLeft,clip2,Clipboard,100

IfNotExist,%perm_cur%%readclip%.clip
  clip2=Clip missing
If clip2=%A_Space%
  clip2=... Word Image
If clip2=
  clip2=... Image
Return

SHOWCLIP:
clip1:=ClipboardAll
clip2=%Null_var%
clip3=%Null_var%

If numofclips=1
  Goto, show_no_prev
activeclip-=1
If activeclip<1
  activeclip=%numofclips%
GoSub,SHOWCLIPsr
clip3= <-1< %clip2%

activeclip+=1
show_no_prev:
If activeclip>%numofclips%
  activeclip=1
GoSub,SHOWCLIPsr
readclipS=%readclip%
clip3=%clip3%`n`n%clip2%
;              
If numofclips=1
{
  clip2=
  clip3=%clip3%`n`n
  Goto, show_no_next
}
activeclip+=1
If activeclip>%numofclips%
  activeclip=1
GoSub,SHOWCLIPsr
clip3=%clip3%`n`n >+1> %clip2%
StringReplace, clip3, clip3,`n`n,`n, All
StringReplace, clip3, clip3,`r`n`r`n,`r`n, All
activeclip-=1
show_no_next:
If activeclip<1
  activeclip=%numofclips%
; ToolTip,Clip %perm_cur% - %activeclip% of %numofclips%`n%clip2% ... 

;SplashTextOn, 450, 80, Clip, %perm_cur% - %activeclip% of %numofclips%`n%clip2% ... 
; WinMove, Clip, , 0, 0 ; Move the splash window to the top left corner. 
; Msgbox, Press OK to dismiss the SplashText
; Progress, m1 b1 fs10 fm10 zh0, %clip2% ..., %perm_cur% - %activeclip% of %numofclips% , Clip, Arial
Progress, m1 b1 H250 W400 fs10 fm8 zh0, %clip3% ..., %perm_cur%%readclipS% - - %activeclip% of %numofclips% , Clip, Arial
;Progress, zh0 fs12 X0 Y0 to locate top right
; showflag true indicates ^v (SHOWCLIP) mode, & enables key ^!v 

showflag = 1
SetTimer,TOOLTIPOFF,Off
Clipboard:=clip1
clip1=
clip2=
clip3=
readclipS=
Return

SHOWCLIP0:
readclip=filearray%activeclip%
readclip:=%readclip%
clip1:=ClipboardAll
IfExist,%perm_cur%%readclip%.clip
  FileRead,Clipboard,*c %perm_cur%%readclip%.clip
StringLeft,clip2,Clipboard,100
If clip2=
  clip2=... Image
ToolTip,Clip %perm_cur% - %activeclip% of %numofclips%`n%clip2% ... 
SetTimer,TOOLTIPOFF,Off
Clipboard:=clip1
clip1=
clip2=
Return
 

PASTECLIP:
readclip=filearray%activeclip%
readclip:=%readclip%
IfExist,%perm_cur%%readclip%.clip
  FileRead,Clipboard,*c %perm_cur%%readclip%.clip
Send,^v
showflag = %Null_var%
delete=no
paste=no
Return


DELETECLIP:
delete=no
paste=no
Return


TOOLTIP:
ToolTip,%tooltip%, 600, 200
SetTimer,TOOLTIPOFF,900
Return


TOOLTIPOFF:
ToolTip,
; SplashTextOff 
Progress, Off
SetTimer,TOOLTIP,Off

Return


INDEX:
filelist=
Loop,%perm_cur%*.clip
{
  StringTrimRight,filename,A_LoopFileName,5
  filelist=%filelist%%filename%`n
}
StringTrimRight,filelist,filelist,1
Sort,filelist,N R
StringSplit,filearray,filelist,`n
numofclips=%filearray0%
Return


FINDNEXT:
  If numofclips<1
  {
    tooltip=%perm_cur% - No clip exists
    Gosub,TOOLTIP
    delete=no
    paste=yes
    Return
  }
activeclip+=1
If activeclip>%numofclips%
  activeclip=1
Return


FINDPREV:
  If numofclips<1
  {
    tooltip=%perm_cur% - No clip exists
    Gosub,TOOLTIP
    delete=no
    paste=yes
    Return
  }
activeclip-=1
If activeclip<1
  activeclip=%numofclips%
Return

